# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from sqlalchemy.orm.util import object_mapper

def _abstract_operator_tbs_listener(connection, target, tbs, tbs_privs=None):

    from basesoft.web.core.util.db import Session
    from we.core.models import WeOperatorLicense
    session = Session()

    group_obj, backref = target.get_group_object()

    # Get the PvcOperatorLicense(s) within this domain
    operators = session.query(WeOperatorLicense).filter(WeOperatorLicense.domain==tbs.domain).all()
    for operator in operators:
        go = group_obj()
        values = {
            '%s_id' % backref: target.id,
            'group_id': operator.default_group.id,
            'privilege': target.PRIV_VIEW,
            'license_has_privilege': True
        }
        connection.execute(object_mapper(go).local_table.insert().values(**values))

    # add it to the TBS as well.

    tbs_privs = tbs_privs if tbs_privs is not None else [target.PRIV_VIEW]

    go = group_obj()
    for priv in tbs_privs:
        values = {
            '%s_id' % backref: target.id,
            'group_id': tbs.default_group.id,
            'privilege': priv,
            'license_has_privilege': True  # FIXME, is this really the case?
        }
        connection.execute(object_mapper(go).local_table.insert().values(**values))
