'''
Created on Dec 17, 2014

@author: marten
'''
from basesoft.web.core.forms.handler import FormValidator
from basesoft.web.core.input.validation import plugins

from we.core.controllers import WeCoreController, UniqueVATNumber


class WeCoreRpcHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.account_id = request.session['user_id']
        self.controller = WeCoreController(self.sa_session, account_id=self.account_id, request=request)

    def get_efta_countries(self):
        return [c.id for c in self.controller.get_efta_countries()]

class WeDefaultRpcHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.account_id = request.session['user_id']

    def validate_company(self, args, kwargs=None):

        unique_vat_args = {'db_session': self.sa_session}
        if kwargs.has_key('require_vat') and kwargs['require_vat'] is True:
            unique_vat_args = dict(unique_vat_args.items() + kwargs.items())

            return FormValidator({
                'name': [(plugins.Required, {})],
                'vat_no': [(plugins.Required, {}), (plugins.VATOffline, {}), (UniqueVATNumber, unique_vat_args)],
            }).validate(args)
        else:
            return FormValidator({
                'name': [(plugins.Required, {})],
            }).validate(args)

    def validate_address(self, args):
        return FormValidator({
            'street': [(plugins.Required, {})],
            'postcode': [(plugins.Required, {})],
            'city': [(plugins.Required, {})],
            'country': [(plugins.Required, {})],
        }).validate(args)

    def validate_person(self, args):
        return FormValidator({
            'first_name': [(plugins.Required, {})],
            'last_name': [(plugins.Required, {})],
            'gender': [(plugins.Required, {})],
            'preferred_locale': [(plugins.Required, {})],
            'email': [(plugins.Required, {}), (plugins.Email, {})],
            'phone': [(plugins.Required, {})],
        }).validate(args)

handlers = (WeCoreRpcHandler, WeDefaultRpcHandler, )