# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from django.conf import settings

from basesoft.web.contrib.soap.server import IQPortalSoapServer
from basesoft.web.contrib.soap.soap import register_soap_functions as iqportal_core_functions

from we.core.soap import register_soap_functions as weee_eu_core_functions
from we.declaration.soap import register_soap_functions as weee_eu_declaration_functions


# TODO: make this dynamic.
tns = 'http://iqportal.we/'
location = '%swe.core/api/' % settings.BASE_URL

def context(request):
    return request

server = IQPortalSoapServer(
    settings={
        'NAME': "weee-eu",
        'CREATE_CONTEXT': context,
        'DEBUG': settings.DEBUG
    },
    service_name="WEEE-EU",
    tns='%s' % tns,
    location='%s' % location,
    headers_schema=False
)

iqportal_core_functions('weee-eu')

weee_eu_core_functions('weee-eu')

weee_eu_declaration_functions('weee-eu')
