# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

# -*- coding: utf-8 -*-

# Copyright (c) 2013 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon


class WeDeclarationManagerIcon(IconBarIcon):

    id = 'icon-we-declaration-manager'
    title = _('Declaration overview')
    href = '#'
    icon_index = 1
    component = 'we_declaration_manager'
    group = 'we_declaration'
    group_title = _('Declarations')
    colorname = 'iconbar-cerulean'

    char_main = u'\uE805'
    char_sub = u'\uE806'

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('we_view_declaration')


def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """

    return [WeDeclarationManagerIcon(), ]
