'''
Created on Feb 9, 2015

@author: rado
'''


from basesoft.web.contrib.notification.models import Notification
from django.utils.translation import ugettext, ugettext_lazy as _


class WeDeclaration(object):
    """
    @DynamicAttrs
    """

    STATUS_COMPLETE = 1
    STATUS_EXPORTED = 2
    STATUS_RESUBMIT = 3

    def __repr__(self):
        return '<WeDeclaration id="%s" lpp_id="%s">' % (self.id, self.lpp_id)


class WeDeclarationLine(WeDeclaration):
    """
    @DynamicAttrs
    """

    def __repr__(self):
        return '<WeDeclarationLine index="%s" declaration_id="%s">' % (self.position, self.declaration_id)


class WeDeclarationReminderNotification(Notification):
    name_i18n = _('Declaration reminder')

    def get_message(self):
        return ugettext("There are no declarations for the latest "
                 "take-back scheme period. Please, make sure you have "
                 "declared before the closing day.")

    def get_subject(self):
        return ugettext('Declaration reminder')

    def __repr__(self):
        return '<WeDeclarationReminderNotification id=%s>' % self.id


class WeDeclarationResubmitNotification(Notification):
    name_i18n = _('Declaration resubmit')

    def get_message(self):
        return ugettext("A producer has updated a declaration that has been exported. "
                        "A new order is ready for export through the middleware.")

    def get_subject(self):
        return ugettext('Declaration resubmit')

    def __repr__(self):
        return '<WeDeclarationResubmitNotification id=%s>' % self.id