'''
Created on Jan 19, 2015

@author: marten
'''

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from basesoft.util.ordered_dict import OrderedDict


class WeMemberOverviewWidget(DashboardWidgetCQStateController):
    label = _('Producer overview')
    name = 'we_member_widget'
    category = _('Producer management')
    permissions = ['we_view_member_license']
    classname = 'palette_group__menu--manager'


class WeLppMasterDataOverviewWidget(DashboardWidgetCQStateController):
    label = _('LPP master data overview')
    name = 'we_lpp_master_data_widget'
    category = _('Producer management')
    permissions = ['we_view_lpp_companies']
    classname = 'palette_group__menu--manager'


widgets_mapper = OrderedDict([
    ('WeMemberOverviewWidget', WeMemberOverviewWidget, ),
    ('WeLppMasterDataOverviewWidget', WeLppMasterDataOverviewWidget, ),
])
