# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.


from basesoft.web.contrib.order.models import Order, OrderLine
from django.utils.translation import ugettext_lazy as _
from django.utils.translation import ugettext


class WeDeclarationOrder(Order):
    """
    @DynamicAttrs
    """

    auto_submit = True  # orders are automatically submitted.

    RESUBMIT_REQUEST_PENDING = 1
    RESUBMIT_REQUEST_APPROVED = 2

    BI_ANNUAL_FIRST_HALF = 1
    BI_ANNUAL_SECOND_HALF = 2

    name_i18n = _('Declaration')

    permissions = ['we_view_declaration_order']

    js_details_module = 'we_order_details'

    def get_order_controller(self):
        from we.order.controllers import WeDeclarationOrderController
        return WeDeclarationOrderController

    def get_name_i18n(self):
        return ugettext('Declaration')

    def __repr__(self):
        return '<WeDeclarationOrder id=%d, lpp="%s" period="TODO">' % (self.order_id, self.lpp)


class WeDeclarationOrderLine(OrderLine):
    """
    @DynamicAttrs
    """

    CREDIT_FIELDS = ('quantity', 'weight', )
