# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.
from basesoft.scheduler.crontab import CronTab
from basesoft.scheduler.task import ScheduleTask
from we.order.controllers import WeDeclarationOrderController
from we.tbs.models import WeTbsLicense


class WeDeclarationOrderTask(ScheduleTask):
    INTERVAL = CronTab('10 0 * * *')  # Every day at 00:10.

    def execute(self):
        dc = WeDeclarationOrderController(self.sa_session)

        tbss = self.sa_session.query(WeTbsLicense).filter(WeTbsLicense.is_active==True)

        for tbs in tbss:
            dc.process_declarations(tbs.id)
            dc.process_resubmits(tbs.id)

tasks = (WeDeclarationOrderTask, )
