'''
Created on Oct 10, 2014

@author: rado
'''
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.iconbar.models import IconBarIcon
from basesoft.web.contrib.account.decorators import assert_user_logged_in


class WeWeeeProductLevelManagerIcon(IconBarIcon):

    id = 'icon-we-product-level-manager'
    title = _('WEEE product categories')
    icon_index = 2
    component = 'we_weee_product_level_manager'
    group = 'product'
    group_title = _('Product management')
    colorname = 'iconbar-corn'

    char_main = u'\uE800' # FIXME

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('we_view_weee_category')


class WeCN8WeeeSubcategoryManagerIcon(IconBarIcon):

    id = 'icon-we-cn8-we-product-level-manager'
    title = _('WEEE CN8 UNU code overview')
    icon_index = 4
    component = 'we_cn8_weee_product_level_manager'
    group = 'product'
    group_title = _('Product management')
    colorname = 'iconbar-corn'

    char_main = u'\uE814' # Arrows recycle icon
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_permissions('we_manage_cn8')

class WeTbsLocalCategoryManagerIcon(IconBarIcon):

    id = 'icon-we-tbs-price-sheet-manager'
    title = _('TBS local categories & fees')
    icon_index = 2
    component = 'we_tbs_price_sheet_manager'
    group = 'tbs'
    group_title = _('TBS management')
    colorname = 'iconbar-clay-creek'

    char_main = u'\uE820'
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_permissions('we_view_tbs_product_level')


class WeHqppProductManagerIcon(IconBarIcon):

    id = 'icon-we-hqpp-product-manager'
    title = _('Producer product portfolio')
    icon_index = 3
    component = 'we_hqpp_product_manager'
    group = 'we_member'
    group_title = _('Producer management')
    colorname = 'iconbar-green-smoke'

    char_main = u'\uE805'
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_permissions('we_view_products')


class WeFileImportManagerIcon(IconBarIcon):

    id = 'icon-we-hqpp-product-file-manager'
    title = _('Product files import status')
    icon_index = 3
    component = 'we_product_file_import_manager'
    group = 'product'
    group_title = _('Product management')
    colorname = 'iconbar-corn'

    char_main = u'\uE805'
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_any_permissions('we_manage_tbs_product_level', 'we_create_products', 'we_manage_cn8')


class WeCN8PeriodProductManagerIcon(IconBarIcon):

    id = 'icon-we-cn8-tbs-product-level-manager'
    title = _('CN8 - Local category links overview')
    icon_index = 3
    component = 'we_cn8_tbs_product_level_manager'
    group = 'tbs'
    group_title = _('TBS management')
    colorname = 'iconbar-clay-creek'

    char_main = u'\uE820'
    char_sub = u'\uE810' # File

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_permissions('we_manage_cn8_tbs_product_level')


def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """

    return [
        WeWeeeProductLevelManagerIcon(),
        WeCN8WeeeSubcategoryManagerIcon(),
        WeTbsLocalCategoryManagerIcon(),
        WeHqppProductManagerIcon(),
        WeFileImportManagerIcon(),
        WeCN8PeriodProductManagerIcon(),
    ]
