# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.
from we.report.controllers import WeReportController


class ReportDimensionHandler:
    def __init__(self, request, **kwargs):

        self._request = request
        self._sa_session = request.Session()
        self._account_id = request.session['user_id']

        self._controller = WeReportController(self._sa_session, account_id=self._account_id, request=self._request)

    def get_tbses(self, datasource, cube, config, values):
        return self._controller.get_tbses(datasource, cube, config, values)

    def get_lpps(self, datasource, cube, config, values):
        return self._controller.get_lpps(datasource, cube, config, values)

    def get_producers(self, datasource, cube, config, values):
        return self._controller.get_producers(datasource, cube, config, values)

    def get_producer_products(self, datasource, cube, config, values):
        return self._controller.get_producer_products(datasource, cube, config, values)

    def get_local_categories(self, datasource, cube, config, values):
        return self._controller.get_local_categories(datasource, cube, config, values)

handlers = (ReportDimensionHandler, )
