# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.

from django.conf import settings

from basesoft.scheduler.crontab import CronTab
from iqportal.iqube.core.schedule import AbstractAggregateTask
from we.report.controllers import WeDeclarationAggregator, WeOrderAggregator


class AggregateWeDeclarationTask(AbstractAggregateTask):

    refresh_datasources = ('%s.WeDeclarationData' % settings.SETTINGS_MODULE, )

    def populate(self):
        affected_rows = 0

        c = WeDeclarationAggregator()
        self._aggregators.append(c)
        affected_rows = affected_rows + c.run(loop_validator=self.loop_validator)

        return affected_rows


class AggregateWeOrderTask(AbstractAggregateTask):
    INTERVAL = CronTab('10 0 * * *')  # Every day at 00:10.

    refresh_datasources = ('%s.WeDeclarationData' % settings.SETTINGS_MODULE, )

    def populate(self):
        affected_rows = 0

        c = WeOrderAggregator()
        self._aggregators.append(c)
        affected_rows = affected_rows + c.run(loop_validator=self.loop_validator)

        return affected_rows


tasks = (AggregateWeDeclarationTask, AggregateWeOrderTask, )