'''
Created on Dec 17, 2014

@author: marten
'''
from basesoft.util.dict import dict_merge
from basesoft.web.core.util.controllers import LicenseConfigController

from we.tbs.controllers import WeTbsController

class WeTbsRpcHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.account_id = request.session['user_id']
        self.wtc = WeTbsController(self.sa_session, account_id=self.account_id, request=request)

    def get_all_tbs(self):
        return [{'value': t.id, 'label': t.name} for t in self.wtc.get_all_tbs()]

    def get_tbses_per_hqpp(self, filters, limit=20):
        return [{'label': t.name, 'value': t.id} for t in self.wtc.get_tbses_per_hqpp(filters.get('filter'), filters.get('value'), limit)]

    def get_all_own_tbs(self):
        l = [{'value': t.id, 'label': t.name} for t in self.wtc.get_all_own_tbs()]
        return sorted(l, key=lambda k: k['label'])

    def load_tbs(self, _id):
        return self.wtc.load_tbs(_id)

    def save_or_update_tbs(self, _id, state):
        tbs = self.wtc.save_or_update_tbs(_id, state)
        return tbs.id

    def save_tbs_settings(self, _id, state):
        orig = self.wtc.load_tbs(_id) # expects state to be filled completly
        s = dict_merge(orig, state)
        s['dbID'] = _id
        license_ = self.wtc.save_license_from_state(s)
        return license_.id

    def get_tbs_configs(self, tbs_id):
        tbs = self.wtc.get_tbs_licenses(tbs_id).pop()
        lcc = LicenseConfigController(self.sa_session, scope=tbs)
        rv = {}
        for k, v in lcc.get_configs().iteritems():
            if k[:2] != 'we':
                continue
            rv[k] = v
        return rv

handlers = (WeTbsRpcHandler,)
